From 6c3e113c46790988dadf5970f1a0af55b8faf011 Mon Sep 17 00:00:00 2001
From: Alessandro Ghedini <alessandro@ghedini.me>
Date: Mon, 21 Jul 2014 17:07:11 +0200
Subject: [PATCH] Implement DH_GOLANG_NO_RECURSE option

Closes: #721496
---
 lib/Debian/Debhelper/Buildsystem/golang.pm | 12 ++++++++++--
 1 file changed, 10 insertions(+), 2 deletions(-)

diff --git a/lib/Debian/Debhelper/Buildsystem/golang.pm b/lib/Debian/Debhelper/Buildsystem/golang.pm
index b34a5f2..7eafb07 100644
--- a/lib/Debian/Debhelper/Buildsystem/golang.pm
+++ b/lib/Debian/Debhelper/Buildsystem/golang.pm
@@ -111,16 +111,24 @@ sub configure {
 
 sub build {
     my $this = shift;
+    my $no_recurse = (exists($ENV{DH_GOLANG_NO_RECURSE}) &&
+                   $ENV{DH_GOLANG_NO_RECURSE} == 1);
+
+    my $pkg = $no_recurse ? "$ENV{DH_GOPKG}" : "$ENV{DH_GOPKG}/...";
 
     $ENV{GOPATH} = $this->{cwd} . '/' . $this->get_builddir();
-    $this->doit_in_builddir("go", "install", "-v", @_, "$ENV{DH_GOPKG}/...");
+    $this->doit_in_builddir("go", "install", "-v", @_, $pkg);
 }
 
 sub test {
     my $this = shift;
+    my $no_recurse = (exists($ENV{DH_GOLANG_NO_RECURSE}) &&
+                   $ENV{DH_GOLANG_NO_RECURSE} == 1);
+
+    my $pkg = $no_recurse ? "$ENV{DH_GOPKG}" : "$ENV{DH_GOPKG}/...";
 
     $ENV{GOPATH} = $this->{cwd} . '/' . $this->get_builddir();
-    $this->doit_in_builddir("go", "test", "-v", @_, "$ENV{DH_GOPKG}/...");
+    $this->doit_in_builddir("go", "test", "-v", @_, $pkg);
 }
 
 sub install {
-- 
2.0.1

